[PACKAGE]: ../../raw/master/mkp/fritzbox_smarthome-0.8.4-20231231.mkp "fritzbox_smarthome-0.8.4-20231231.mkp"
# AVM Fritz!Box Smarthome

This repository contains a additional check_MK Fritz!Box Agent which can gather informations over the AVM AHA HTTP Interface about SmartHome Devices connected to an Fritz!Box. 

This package is based on the work of Maximilian Clemens [(see Acknowledgements)](#acknowledgements). I have rewritten this package for use with CMK 2.2.0x. As I do not have access to all Smarthome devices, I have only implemented the checks for the following devices:

- FRITZ!DECT Repeater 100
- FRITZ!DECT 200
- FRITZ!DECT 302

So if you want the package to be extended to support your sensors as well, see [Want to Contribute?](CONTRIBUTING.md) Also, my FRIT!BOX is not brand new, so it may not include all the features that the Smnarthome devices support. E.g. window open/close for the FRITZ!DECT 302.

---
### Acknowledgments

This packages is based on the werk by [MaximilianClemens](https://github.com/MaximilianClemens) see [checkmk_fritzbox on GitHub](https://github.com/MaximilianClemens/checkmk_fritzbox)

---
### Packages contents

<details><summary>This package contains the follwing plugins</summary>


| File | Description |
| ------ | ------ |
| agent_fritzbox_smarthome.py        | the actual agent |
| fritzbox_smarthome.py              | the base chaeck plugin |
| fritzbox_smarthome_app_lock.py     | shows if the device can be acssed by App, Phone or UI |
| fritzbox_smarthome_battery.py      | shows the the battery state |
| fritzbox_smarthome_device_lock.py  | shows if the button on the device are locked or not |
| fritzbox_smarthome_power_meter.py  | shows voltage, electrical power and electrical eneregy  |
| fritzbox_smarthome_power_socket.py | shows the status of a switchable power socket |
| fritzbox_smarthome_switch.py       | shows the status of a simple switch (on/off) |
| fritzbox_smarthome_temperature.py  | shows the temeprature and offset of a themperature sensor |
| fritzbox_smarthome_thermostat.py   | shows the working states of a thermostat (radiator controller) |
| inv_fritzbox_smarthome.py          | adds the smarthome devices to the CMK HW/SW inventory |

</details>

---
### Usage

<details><summary>How to configure the agent</summary>

**Note**: Before using this agent, please make sure that the names of your smart home devices are compatible with CMK.
CMK only allows `.-_a-zA-Z0-9`. If your devices do not follow this pattern, the agent replaces ` ` (space) with `_` and removes all other non-allowed characters from the host names.

After installing the package, create a new WATO rule **Setup -> Other integrations -> Fritz!Box Smarthome devices**.
Here you need at least the user name and password to log in to your Fritz!Box For the password, I recommend using the CMK password store. The agent uses HTTPS on port TCP/443 by default and checks the certificate of your Fritz!Box, so if you do not have a good certificate, activate the option `Ignore SSL errors`. Don't forget to use your Fritz!Box as a condition with **Explicit hosts**.

By default, the agent uses the CMK piggyback mechanism for the Smarthome devices. Depending on your CMK edition, you therefore have two options for adding these hosts. In the _RAW_ edition, you create them like any other host object (by hand, CSV, API). Set the following fields:
- IP address family -> No IP
- Checkmk agent / API integrations -> No API integration, no Checkmk agent
- SNMP -> no SNMP
- Piggyback -> Always use and expect piggyback data

In all othe editions you can use the Dynamic host management (DCD) to do this job for you. See _Setup_ -> _Dynamic host management_.

Now you are ready to let CMK find your Smarthomne devices.

</details>

```
OMD[build]:~$ ~/local/share/check_mk/agents/special/agent_fritzbox_smarthome --help
usage: agent_fritzbox_smarthome [-h] [--debug] [--ignore_ssl] [--no-piggyback] [--password [PASSWORD]]
                                [--username [USERNAME]] [--port [PORT]] [--prefix [PREFIX]]
                                [--protocol [{http,https}]] [--testing]
                                host

Check_MK Fritz!Box Smarthome Agent
This is an additional check_MK Fritz!Box Agent which can gather information's over the 
AVM AHA HTTP Interface about SmartHome Devices connected to an Fritz!Box.

positional arguments:
  host                  Host name or IP address of your Fritz!Box

options:
  -h, --help            show this help message and exit
  --debug               Debug mode: let Python exceptions come through
  --ignore_ssl          Tha agent will ignores SSL errors
  --no-piggyback        By default the agent generates the output as piggyback data for each
                        Samrthome device. If you want to attach all your Smarthome devices directly
                         to your Fritz!Box use this option.
  --password [PASSWORD]
                        The password to logon the Fritz!Box
  --username [USERNAME]
                        The username to logon to the Fritz!Box
  --port [PORT]         The TCP port on witch to access the Fritz!Box
  --prefix [PREFIX]     The prefix is used to group all the Smarthome devices from one Fritz!Box in CMK.
  --protocol [{http,https}]
                        The protocol used to access the Fritz!Box
  --testing             Development usage only (might be ignored)
```

---
### Download
* [Download latest mkp file][PACKAGE]

**Note**: before you update to a newer version, always check the [CHANGELOG](CHANGELOG). There migth be incompatible changes.
                        
---
### Installation

You can install the package by uploading it to your CheckMK site and as site user run 
```
mkp add PAKAGE_NAME.mkp
mkp enable PAKAGE_NAME VERSION
```

In the Enterprise/Free/Cloud edition of CheckMK you can use the GUI to install the package (_Setup_ -> _Extension Packages_ -> _Upload package_)

---
### Want to Contribute?

Nice ;-) Have a look at the [contribution guidelines](CONTRIBUTING.md "Contributing")

---
### Check Info

The plugin creates the service **_SERVICENAME_** for each discovered FOR WHAT with the **_HOW_TO_BUILD_THE_ITEM_** as item

<details><summary>Montoring states</summary>

| State | condition | WATO | 
| ------ | ------ | ------ |
| WARN | condition 1 | yes |
| CRIT | condition 2 | no |
| WARN/CRIT | condition 3 | no |

</details>

<details><summary>Perfdata</summary>

| Metric | Unit | Perfometer |
| ------ | ------ | ------ |
| METRIC 1 | bit/s | yes |
| METRIC 2 | C | yes |
| METRIC 3 | V | no |

</details>

---
### WATO
<details><summary>Service monitoring rule</summary>

| Section | Rule name |
| ------ | ------ |
| Networking | NAME_OF_THE_RULE  |

| Option | Defailt value |
| ------ | ------ |
| OPTION 1 | 10/50|
| OPTION 2 | 70/90 |
| OPTION 3 | CHOICE 1 |
| OPTION 4 | disabled |

</details> 

<details><summary>Special agent rule</summary>

-> Setup -> Agents -> Other integrations

| Section  | Rule name |
| -------  | --------- |
| Hardware | Fritz!Box Smarthome Devices |

| Option | Description | Defailt value |
| ------ | ------------| ------------- |
| Username | no default | Username to logon to the FritzBox |
| Password | no default | Password for the user to log on|
| Port | 443 | The TCP Port used to connect to the Fritz!Box |
| Protocol | HTTPS | The Protocol used to connect to the Fritz!Box |
| Ignore SSL errors | don't ignire errors | Tha agent will ignores SSL errors |
| Add Prefix | don't add prefx | The prefix is used to group all the Smarthome devices from one Fritz!Box in CMK |
| Disable piggyback | use piggyback | If you want to attach all your Smarthome devices directly to your Fritz!Box use this option |
| Add test data | disabled | only for development, will be removed |

</details> 

<details><summary>Discovery rule</summary>
There is on discovery rule.
</details> 

<details><summary>HW/SW inventory rules</summary>
The inventory plugin is not configurable.
</details> 

---
### Sample Output

Sample output

![sample output](/img/sample.png?raw=true "sample output")

Sample output details

![sample output details](/img/sample-details.png?raw=true "sample output details")

Sample inventory

![sampleinventory](/img/sample_inventory.png?raw=true "sample inventory")
